#ifndef COORDINATE_SYSTEM_H
#define COORDINATE_SYSTEM_H

#include <qpainter.h>
#include <qpushbutton.h>
#include <qboxlayout.h>
#include <qspinbox.h>
#include <qlabel.h>

#define centerX width() / 2
#define centerY height() / 2

class CoordinateSystem : public QWidget {
  Q_OBJECT
  QPushButton *button;
  short step = 50;
  std::vector<std::array<QSpinBox *, 2>> fields;
  QPainter *painter;
  std::vector<std::vector<short>> dots;
  QPushButton *adddialog;
  QGridLayout *layout;
  QWidget *container;
  QPushButton *clearb;
  QPushButton *addb;
  QSpinBox *displayus;
  QLabel* text;
  QLabel* text2;
  QDoubleSpinBox *tStart;
  QDoubleSpinBox *tEnd;
  QSpinBox *iIndex;
  QDoubleSpinBox *tabIndex;
  QLabel *resultLabel;
protected:
  void paintEvent(QPaintEvent*) override;
public:
  CoordinateSystem(QWidget *parent = nullptr);
private slots:
  void onButtonClick();
  void up();
  void add();
  void clear();
  void finalize();
  void addandfix();
  void updateResultText();
  void updateStart();
  void updateEnd();
};

#endif // COORDINATE_SYSTEM_H
